package cn.com.qmth.mps.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.qmth.boot.api.constant.ApiConstant;

import cn.com.qmth.mps.bean.User;
import cn.com.qmth.mps.service.AuthService;
import cn.com.qmth.mps.vo.AdminLoginVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@Api(tags = "登录相关接口")
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/auth")
public class AuthController extends BaseController {
	@Autowired
	private AuthService authService;

	@ApiOperation(value = "管理端登录")
	@PostMapping("login/admin")
	public AdminLoginVo loginAdmin(@RequestParam String loginName, @RequestParam String password) {
		return authService.loginAdmin(loginName,password);
	}

	@ApiOperation(value = "微信小程序登录")
	@PostMapping("login/wxapp/code")
	public AdminLoginVo loginWxAppCode(@RequestParam String wxappCode) {
		return authService.loginWxAppCode(wxappCode);
	}
	
	@ApiOperation(value = "微信小程序登录")
	@PostMapping("login/wxapp/encrypted-data")
	public AdminLoginVo loginWxAppEncryptedData(@RequestParam String wxappCode,@RequestParam String encryptedData,@RequestParam String iv) {
		return authService.loginWxAppEncryptedData(wxappCode,encryptedData,iv);
	}

	@ApiOperation(value = "登出")
	@PostMapping("logout")
	public void logout() {
		User user = getAccessUser();
        authService.logout(user);
	}

}